// autogenerated by syzkaller (http://github.com/google/syzkaller)

#define _GNU_SOURCE

#include <arpa/inet.h>
#include <errno.h>
#include <errno.h>
#include <errno.h>
#include <fcntl.h>
#include <fcntl.h>
#include <linux/if.h>
#include <linux/if_ether.h>
#include <linux/if_tun.h>
#include <linux/ip.h>
#include <linux/tcp.h>
#include <net/if_arp.h>
#include <sched.h>
#include <signal.h>
#include <stdarg.h>
#include <stdarg.h>
#include <stdarg.h>
#include <stdbool.h>
#include <stdbool.h>
#include <stdbool.h>
#include <stdio.h>
#include <stdio.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/ioctl.h>
#include <sys/prctl.h>
#include <sys/resource.h>
#include <sys/stat.h>
#include <sys/stat.h>
#include <sys/syscall.h>
#include <sys/time.h>
#include <sys/uio.h>
#include <sys/wait.h>
#include <unistd.h>

__attribute__((noreturn)) static void doexit(int status)
{
  volatile unsigned i;
  syscall(__NR_exit_group, status);
  for (i = 0;; i++) {
  }
}

#include <setjmp.h>
#include <signal.h>
#include <stdint.h>
#include <string.h>
#include <string.h>

const int kFailStatus = 67;
const int kRetryStatus = 69;

static void fail(const char* msg, ...)
{
  int e = errno;
  va_list args;
  va_start(args, msg);
  vfprintf(stderr, msg, args);
  va_end(args);
  fprintf(stderr, " (errno %d)\n", e);
  doexit((e == ENOMEM || e == EAGAIN) ? kRetryStatus : kFailStatus);
}

static void exitf(const char* msg, ...)
{
  int e = errno;
  va_list args;
  va_start(args, msg);
  vfprintf(stderr, msg, args);
  va_end(args);
  fprintf(stderr, " (errno %d)\n", e);
  doexit(kRetryStatus);
}

static __thread int skip_segv;
static __thread jmp_buf segv_env;

static void segv_handler(int sig, siginfo_t* info, void* uctx)
{
  uintptr_t addr = (uintptr_t)info->si_addr;
  const uintptr_t prog_start = 1 << 20;
  const uintptr_t prog_end = 100 << 20;
  if (__atomic_load_n(&skip_segv, __ATOMIC_RELAXED) &&
      (addr < prog_start || addr > prog_end)) {
    _longjmp(segv_env, 1);
  }
  doexit(sig);
  for (;;) {
  }
}

static void install_segv_handler()
{
  struct sigaction sa;

  memset(&sa, 0, sizeof(sa));
  sa.sa_handler = SIG_IGN;
  syscall(SYS_rt_sigaction, 0x20, &sa, NULL, 8);
  syscall(SYS_rt_sigaction, 0x21, &sa, NULL, 8);

  memset(&sa, 0, sizeof(sa));
  sa.sa_sigaction = segv_handler;
  sa.sa_flags = SA_NODEFER | SA_SIGINFO;
  sigaction(SIGSEGV, &sa, NULL);
  sigaction(SIGBUS, &sa, NULL);
}

#define NONFAILING(...)                                                \
  {                                                                    \
    __atomic_fetch_add(&skip_segv, 1, __ATOMIC_SEQ_CST);               \
    if (_setjmp(segv_env) == 0) {                                      \
      __VA_ARGS__;                                                     \
    }                                                                  \
    __atomic_fetch_sub(&skip_segv, 1, __ATOMIC_SEQ_CST);               \
  }

static void vsnprintf_check(char* str, size_t size, const char* format,
                            va_list args)
{
  int rv;

  rv = vsnprintf(str, size, format, args);
  if (rv < 0)
    fail("tun: snprintf failed");
  if ((size_t)rv >= size)
    fail("tun: string '%s...' doesn't fit into buffer", str);
}

static void snprintf_check(char* str, size_t size, const char* format,
                           ...)
{
  va_list args;

  va_start(args, format);
  vsnprintf_check(str, size, format, args);
  va_end(args);
}

#define COMMAND_MAX_LEN 128
#define PATH_PREFIX                                                    \
  "PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin "
#define PATH_PREFIX_LEN (sizeof(PATH_PREFIX) - 1)

static void execute_command(const char* format, ...)
{
  va_list args;
  char command[PATH_PREFIX_LEN + COMMAND_MAX_LEN];
  int rv;

  va_start(args, format);
  memcpy(command, PATH_PREFIX, PATH_PREFIX_LEN);
  vsnprintf_check(command + PATH_PREFIX_LEN, COMMAND_MAX_LEN, format,
                  args);
  rv = system(command);
  if (rv != 0)
    fail("tun: command \"%s\" failed with code %d", &command[0], rv);

  va_end(args);
}

static int tunfd = -1;
static int tun_frags_enabled;

#define SYZ_TUN_MAX_PACKET_SIZE 1000

#define MAX_PIDS 32
#define ADDR_MAX_LEN 32

#define LOCAL_MAC "aa:aa:aa:aa:aa:%02hx"
#define REMOTE_MAC "bb:bb:bb:bb:bb:%02hx"

#define LOCAL_IPV4 "172.20.%d.170"
#define REMOTE_IPV4 "172.20.%d.187"

#define LOCAL_IPV6 "fe80::%02hxaa"
#define REMOTE_IPV6 "fe80::%02hxbb"

#define IFF_NAPI 0x0010
#define IFF_NAPI_FRAGS 0x0020

static void initialize_tun(uint64_t pid)
{
  if (pid >= MAX_PIDS)
    fail("tun: no more than %d executors", MAX_PIDS);
  int id = pid;

  tunfd = open("/dev/net/tun", O_RDWR | O_NONBLOCK);
  if (tunfd == -1) {
    printf(
        "tun: can't open /dev/net/tun: please enable CONFIG_TUN=y\n");
    printf("otherwise fuzzing or reproducing might not work as "
           "intended\n");
    return;
  }

  char iface[IFNAMSIZ];
  snprintf_check(iface, sizeof(iface), "syz%d", id);

  struct ifreq ifr;
  memset(&ifr, 0, sizeof(ifr));
  strncpy(ifr.ifr_name, iface, IFNAMSIZ);
  ifr.ifr_flags = IFF_TAP | IFF_NO_PI | IFF_NAPI | IFF_NAPI_FRAGS;
  if (ioctl(tunfd, TUNSETIFF, (void*)&ifr) < 0) {
    ifr.ifr_flags = IFF_TAP | IFF_NO_PI;
    if (ioctl(tunfd, TUNSETIFF, (void*)&ifr) < 0)
      fail("tun: ioctl(TUNSETIFF) failed");
  }
  if (ioctl(tunfd, TUNGETIFF, (void*)&ifr) < 0)
    fail("tun: ioctl(TUNGETIFF) failed");
  tun_frags_enabled = (ifr.ifr_flags & IFF_NAPI_FRAGS) != 0;

  char local_mac[ADDR_MAX_LEN];
  snprintf_check(local_mac, sizeof(local_mac), LOCAL_MAC, id);
  char remote_mac[ADDR_MAX_LEN];
  snprintf_check(remote_mac, sizeof(remote_mac), REMOTE_MAC, id);

  char local_ipv4[ADDR_MAX_LEN];
  snprintf_check(local_ipv4, sizeof(local_ipv4), LOCAL_IPV4, id);
  char remote_ipv4[ADDR_MAX_LEN];
  snprintf_check(remote_ipv4, sizeof(remote_ipv4), REMOTE_IPV4, id);

  char local_ipv6[ADDR_MAX_LEN];
  snprintf_check(local_ipv6, sizeof(local_ipv6), LOCAL_IPV6, id);
  char remote_ipv6[ADDR_MAX_LEN];
  snprintf_check(remote_ipv6, sizeof(remote_ipv6), REMOTE_IPV6, id);

  execute_command("sysctl -w net.ipv6.conf.%s.accept_dad=0", iface);

  execute_command("sysctl -w net.ipv6.conf.%s.router_solicitations=0",
                  iface);

  execute_command("ip link set dev %s address %s", iface, local_mac);
  execute_command("ip addr add %s/24 dev %s", local_ipv4, iface);
  execute_command("ip -6 addr add %s/120 dev %s", local_ipv6, iface);
  execute_command("ip neigh add %s lladdr %s dev %s nud permanent",
                  remote_ipv4, remote_mac, iface);
  execute_command("ip -6 neigh add %s lladdr %s dev %s nud permanent",
                  remote_ipv6, remote_mac, iface);
  execute_command("ip link set dev %s up", iface);
}

static void setup_tun(uint64_t pid, bool enable_tun)
{
  if (enable_tun)
    initialize_tun(pid);
}

static void loop();

static void sandbox_common()
{
  prctl(PR_SET_PDEATHSIG, SIGKILL, 0, 0, 0);
  setpgrp();
  setsid();

  struct rlimit rlim;
  rlim.rlim_cur = rlim.rlim_max = 128 << 20;
  setrlimit(RLIMIT_AS, &rlim);
  rlim.rlim_cur = rlim.rlim_max = 8 << 20;
  setrlimit(RLIMIT_MEMLOCK, &rlim);
  rlim.rlim_cur = rlim.rlim_max = 1 << 20;
  setrlimit(RLIMIT_FSIZE, &rlim);
  rlim.rlim_cur = rlim.rlim_max = 1 << 20;
  setrlimit(RLIMIT_STACK, &rlim);
  rlim.rlim_cur = rlim.rlim_max = 0;
  setrlimit(RLIMIT_CORE, &rlim);

#define CLONE_NEWCGROUP 0x02000000

  unshare(CLONE_NEWNS);
  unshare(CLONE_NEWIPC);
  unshare(CLONE_NEWCGROUP);
  unshare(CLONE_NEWNET);
  unshare(CLONE_NEWUTS);
  unshare(CLONE_SYSVSEM);
}

static int do_sandbox_none(int executor_pid, bool enable_tun)
{
  unshare(CLONE_NEWPID);
  int pid = fork();
  if (pid < 0)
    fail("sandbox fork failed");
  if (pid)
    return pid;

  sandbox_common();
  setup_tun(executor_pid, enable_tun);

  loop();
  doexit(1);
}

static bool write_file(const char* file, const char* what, ...)
{
  char buf[1024];
  va_list args;
  va_start(args, what);
  vsnprintf(buf, sizeof(buf), what, args);
  va_end(args);
  buf[sizeof(buf) - 1] = 0;
  int len = strlen(buf);

  int fd = open(file, O_WRONLY | O_CLOEXEC);
  if (fd == -1)
    return false;
  if (write(fd, buf, len) != len) {
    close(fd);
    return false;
  }
  close(fd);
  return true;
}

static int inject_fault(int nth)
{
  int fd;
  char buf[16];

  fd = open("/proc/thread-self/fail-nth", O_RDWR);
  if (fd == -1)
    exitf("failed to open /proc/thread-self/fail-nth");
  sprintf(buf, "%d", nth + 1);
  if (write(fd, buf, strlen(buf)) != (ssize_t)strlen(buf))
    exitf("failed to write /proc/thread-self/fail-nth");
  return fd;
}

void loop()
{
  syscall(__NR_mmap, 0x20000000ul, 0xfff000ul, 0x3ul, 0x32ul,
          0xfffffffffffffffful, 0x0ul);
  NONFAILING(*(uint32_t*)0x20b8cf88 = (uint32_t)0x2);
  NONFAILING(*(uint32_t*)0x20b8cf8c = (uint32_t)0x78);
  NONFAILING(*(uint8_t*)0x20b8cf90 = (uint8_t)0xe3);
  NONFAILING(*(uint8_t*)0x20b8cf91 = (uint8_t)0x0);
  NONFAILING(*(uint8_t*)0x20b8cf92 = (uint8_t)0x0);
  NONFAILING(*(uint8_t*)0x20b8cf93 = (uint8_t)0x0);
  NONFAILING(*(uint32_t*)0x20b8cf94 = (uint32_t)0x0);
  NONFAILING(*(uint64_t*)0x20b8cf98 = (uint64_t)0x0);
  NONFAILING(*(uint64_t*)0x20b8cfa0 = (uint64_t)0x0);
  NONFAILING(*(uint64_t*)0x20b8cfa8 = (uint64_t)0x0);
  NONFAILING(*(uint8_t*)0x20b8cfb0 = (uint8_t)0x80000040fe);
  NONFAILING(*(uint8_t*)0x20b8cfb1 = (uint8_t)0x0);
  NONFAILING(*(uint8_t*)0x20b8cfb2 = (uint8_t)0x0);
  NONFAILING(*(uint8_t*)0x20b8cfb3 = (uint8_t)0x0);
  NONFAILING(*(uint32_t*)0x20b8cfb4 = (uint32_t)0x0);
  NONFAILING(*(uint32_t*)0x20b8cfb8 = (uint32_t)0x0);
  NONFAILING(*(uint32_t*)0x20b8cfbc = (uint32_t)0x0);
  NONFAILING(*(uint64_t*)0x20b8cfc0 = (uint64_t)0x0);
  NONFAILING(*(uint64_t*)0x20b8cfc8 = (uint64_t)0x0);
  NONFAILING(*(uint64_t*)0x20b8cfd0 = (uint64_t)0x0);
  NONFAILING(*(uint64_t*)0x20b8cfd8 = (uint64_t)0x0);
  NONFAILING(*(uint64_t*)0x20b8cfe0 = (uint64_t)0x0);
  NONFAILING(*(uint32_t*)0x20b8cfe8 = (uint32_t)0x0);
  NONFAILING(*(uint64_t*)0x20b8cff0 = (uint64_t)0x0);
  NONFAILING(*(uint32_t*)0x20b8cff8 = (uint32_t)0x0);
  NONFAILING(*(uint16_t*)0x20b8cffc = (uint16_t)0x0);
  NONFAILING(*(uint16_t*)0x20b8cffe = (uint16_t)0x0);
  syscall(__NR_perf_event_open, 0x20b8cf88ul, 0x0ul, 0x0ul,
          0xfffffffffffffffful, 0x0ul);
  NONFAILING(*(uint64_t*)0x202e2000 = (uint64_t)0x0);
  NONFAILING(*(uint16_t*)0x202e2008 = (uint16_t)0x2);
  NONFAILING(*(uint16_t*)0x202e200a = (uint16_t)0x204e);
  NONFAILING(*(uint8_t*)0x202e200c = (uint8_t)0xac);
  NONFAILING(*(uint8_t*)0x202e200d = (uint8_t)0x14);
  NONFAILING(*(uint8_t*)0x202e200e = (uint8_t)0x0);
  NONFAILING(*(uint8_t*)0x202e200f = (uint8_t)0xbb);
  NONFAILING(*(uint8_t*)0x202e2010 = (uint8_t)0x0);
  NONFAILING(*(uint8_t*)0x202e2011 = (uint8_t)0x0);
  NONFAILING(*(uint8_t*)0x202e2012 = (uint8_t)0x0);
  NONFAILING(*(uint8_t*)0x202e2013 = (uint8_t)0x0);
  NONFAILING(*(uint8_t*)0x202e2014 = (uint8_t)0x0);
  NONFAILING(*(uint8_t*)0x202e2015 = (uint8_t)0x0);
  NONFAILING(*(uint8_t*)0x202e2016 = (uint8_t)0x0);
  NONFAILING(*(uint8_t*)0x202e2017 = (uint8_t)0x0);
  NONFAILING(*(uint16_t*)0x202e2018 = (uint16_t)0x2);
  NONFAILING(*(uint16_t*)0x202e201a = (uint16_t)0x204e);
  NONFAILING(*(uint8_t*)0x202e201c = (uint8_t)0xac);
  NONFAILING(*(uint8_t*)0x202e201d = (uint8_t)0x14);
  NONFAILING(*(uint8_t*)0x202e201e = (uint8_t)0x0);
  NONFAILING(*(uint8_t*)0x202e201f = (uint8_t)0xaa);
  NONFAILING(*(uint8_t*)0x202e2020 = (uint8_t)0x0);
  NONFAILING(*(uint8_t*)0x202e2021 = (uint8_t)0x0);
  NONFAILING(*(uint8_t*)0x202e2022 = (uint8_t)0x0);
  NONFAILING(*(uint8_t*)0x202e2023 = (uint8_t)0x0);
  NONFAILING(*(uint8_t*)0x202e2024 = (uint8_t)0x0);
  NONFAILING(*(uint8_t*)0x202e2025 = (uint8_t)0x0);
  NONFAILING(*(uint8_t*)0x202e2026 = (uint8_t)0x0);
  NONFAILING(*(uint8_t*)0x202e2027 = (uint8_t)0x0);
  NONFAILING(*(uint16_t*)0x202e2028 = (uint16_t)0x2);
  NONFAILING(*(uint16_t*)0x202e202a = (uint16_t)0x204e);
  NONFAILING(*(uint32_t*)0x202e202c = (uint32_t)0x100007f);
  NONFAILING(*(uint8_t*)0x202e2030 = (uint8_t)0x0);
  NONFAILING(*(uint8_t*)0x202e2031 = (uint8_t)0x0);
  NONFAILING(*(uint8_t*)0x202e2032 = (uint8_t)0x0);
  NONFAILING(*(uint8_t*)0x202e2033 = (uint8_t)0x0);
  NONFAILING(*(uint8_t*)0x202e2034 = (uint8_t)0x0);
  NONFAILING(*(uint8_t*)0x202e2035 = (uint8_t)0x0);
  NONFAILING(*(uint8_t*)0x202e2036 = (uint8_t)0x0);
  NONFAILING(*(uint8_t*)0x202e2037 = (uint8_t)0x0);
  NONFAILING(*(uint16_t*)0x202e2038 = (uint16_t)0x0);
  NONFAILING(*(uint16_t*)0x202e203a = (uint16_t)0x0);
  NONFAILING(*(uint64_t*)0x202e2040 = (uint64_t)0x0);
  NONFAILING(*(uint64_t*)0x202e2048 = (uint64_t)0x0);
  NONFAILING(*(uint16_t*)0x202e2050 = (uint16_t)0x0);
  NONFAILING(*(uint64_t*)0x202e2058 = (uint64_t)0x20000000);
  NONFAILING(*(uint64_t*)0x202e2060 = (uint64_t)0x12d);
  NONFAILING(*(uint64_t*)0x202e2068 = (uint64_t)0x2);
  NONFAILING(*(uint16_t*)0x202e2070 = (uint16_t)0x2);
  syscall(__NR_ioctl, 0xfffffffffffffffful, 0x890bul, 0x202e2000ul);
  NONFAILING(memcpy((void*)0x20e06ff8, "./file0", 8));
  syscall(__NR_open, 0x20e06ff8ul, 0x80040ul, 0x0ul);
  NONFAILING(memcpy((void*)0x20b85ff8, "./file0", 8));
  NONFAILING(memcpy((void*)0x202b9000, "./file0", 8));
  NONFAILING(memcpy((void*)0x20f9effa, "tmpfs", 6));
  write_file("/sys/kernel/debug/failslab/ignore-gfp-wait", "N");
  write_file("/sys/kernel/debug/fail_futex/ignore-private", "N");
  inject_fault(14);
  syscall(__NR_mount, 0x20b85ff8ul, 0x202b9000ul, 0x20f9effaul, 0x0ul,
          0x207caf71ul);
}

int main()
{
  install_segv_handler();
  int pid = do_sandbox_none(0, true);
  int status = 0;
  while (waitpid(pid, &status, __WALL) != pid) {
  }
  return 0;
}
